> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://hiddenlayer.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://hiddenlayer.ferndocs.com/_mcp/server.

# Upsert Models

PUT https://api.hiddenlayer.ai/api/v2/models
Content-Type: application/json

Reference: https://hiddenlayer.ferndocs.com/api-reference/llm-proxy-api/models/upsert

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.hiddenlayer.ai` (ProdUs, default)
- `https://api.eu.hiddenlayer.ai` (ProdEu)

## Request

### Body (application/json)

This endpoint expects a list of SensorSORModel.

- `list of SensorSORModel`

## Response

### 200

Successful response

- `details` (string, optional)

## Errors

### 400 Bad Request Error

The request failed due to a client error, with one or more of the following possible causes: 1. The request required a tenant_id field, which was missing. 2. The request was malformed syntactically or semantically.

- `any`

### 503 Service Unavailable Error

The service is undergoing maintenance and is temporarily unavailable.

- `any`

## Types

### SensorSORModel

- `name` (string, required)
- `source` (string, required)
- `model_id` (string, optional)
- `tenant_id` (string, optional)
- `versions` (list of SensorSORModelVersion, optional)

### SensorSORModelVersion

- `version` (string, required)
- `model_version_id` (string, optional)
- `tags` (map from string to any, optional)
- `locations` (map from string to any, optional)
- `deployments` (list of SensorSORDeployment, optional)
- `multi_file` (boolean, optional)
- `retrievable` (boolean, optional)

### SensorSORDeployment

- `path` (string, optional)
- `active` (boolean, optional)

## Examples

**Request**

```json
[
  {
    "name": "loan application",
    "source": "azure"
  }
]
```

**Response**

```json
{
  "details": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.hiddenlayer.ai/api/v2/models"

payload = [
    {
        "name": "loan application",
        "source": "azure"
    }
]
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.hiddenlayer.ai/api/v2/models';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '[{"name":"loan application","source":"azure"}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.hiddenlayer.ai/api/v2/models"

	payload := strings.NewReader("[\n  {\n    \"name\": \"loan application\",\n    \"source\": \"azure\"\n  }\n]")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.hiddenlayer.ai/api/v2/models")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"name\": \"loan application\",\n    \"source\": \"azure\"\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.hiddenlayer.ai/api/v2/models")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"name\": \"loan application\",\n    \"source\": \"azure\"\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.hiddenlayer.ai/api/v2/models', [
  'body' => '[
  {
    "name": "loan application",
    "source": "azure"
  }
]',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.hiddenlayer.ai/api/v2/models");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"name\": \"loan application\",\n    \"source\": \"azure\"\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "name": "loan application",
    "source": "azure"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.hiddenlayer.ai/api/v2/models")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```